"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var routing_controllers_1 = require("routing-controllers");
/**
 * Decorator fetch decoded user token from contecxt, use it before put
 * parsed token to context
 * @param options
 */
function KeycloakToken(options) {
    return routing_controllers_1.createParamDecorator({
        required: options && options.required ? true : false,
        value: function (action) {
            var token = action.context['decoded-user-token'];
            if (!token) {
                throw new Error('empty token, on KeycloakToken decorator');
            }
            return token;
        }
    });
}
exports.KeycloakToken = KeycloakToken;
